SuperLU: SRC/claqgs.c File Reference

# SRC/claqgs.c File Reference

Equlibrates a general sprase matrix. More...

`#include <math.h>`
`#include "slu_cdefs.h"`

## Defines
#define | THRESH (0.1)
## Functions
void | claqgs (SuperMatrix *A, float *r, float *c, float rowcnd, float colcnd, float amax, char *equed)

## Detailed Description

     -- SuperLU routine (version 2.0) --
     Univ. of California Berkeley, Xerox Palo Alto Research Center,
     and Lawrence Berkeley National Lab.
     November 15, 1997

     Modified from LAPACK routine CLAQGE

## Define Documentation

#define THRESH (0.1)

## Function Documentation

void claqgs | ( | SuperMatrix * | A,
|  | float * | r,
|  | float * | c,
|  | float | rowcnd,
|  | float | colcnd,
|  | float | amax,
|  | char * | equed |
| ) |  |  |

       Purpose
       =======

       CLAQGS equilibrates a general sparse M by N matrix A using the row and
       scaling factors in the vectors R and C.

       See supermatrix.h for the definition of 'SuperMatrix' structure.

       Arguments
       =========

       A       (input/output) SuperMatrix*
               On exit, the equilibrated matrix.  See EQUED for the form of
               the equilibrated matrix. The type of A can be:
    	    Stype = NC; Dtype = SLU_C; Mtype = GE.

       R       (input) float*, dimension (A->nrow)
               The row scale factors for A.

       C       (input) float*, dimension (A->ncol)
               The column scale factors for A.

       ROWCND  (input) float
               Ratio of the smallest R(i) to the largest R(i).

       COLCND  (input) float
               Ratio of the smallest C(i) to the largest C(i).

       AMAX    (input) float
               Absolute value of largest matrix entry.

       EQUED   (output) char*
               Specifies the form of equilibration that was done.
               = 'N':  No equilibration
               = 'R':  Row equilibration, i.e., A has been premultiplied by
                       diag(R).
               = 'C':  Column equilibration, i.e., A has been postmultiplied
                       by diag(C).
               = 'B':  Both row and column equilibration, i.e., A has been
                       replaced by diag(R) * A * diag(C).

       Internal Parameters
       ===================

       THRESH is a threshold value used to decide if row or column scaling
       should be done based on the ratio of the row or column scaling
       factors.  If ROWCND < THRESH, row scaling is done, and if
       COLCND < THRESH, column scaling is done.

       LARGE and SMALL are threshold values used to decide if row scaling
       should be done based on the absolute size of the largest matrix
       element.  If AMAX > LARGE or AMAX < SMALL, row scaling is done.

       =====================================================================